
//last Update 30/09/2017
// add local variables  in LCD_4x20_I2C.c

//03-09-2017  reduction des delais
// Fosc 16MHz sur MCU
#define LCD_ADDR 0x4E     // PCF8574 on pigboard YwRobot back located  on LCD4x20
// PCF8574 I2C LCD Port Definition
// P7,P6,P5,P4 = Data, P3=Backlight (BL), P2=E, P1=RW, P0=RS
#define LCD_BL 0x08
#define LCD_EN 0x04
#define LCD_RW 0x02
#define LCD_RS 0x01

// ref : ODT OCM-20416D-A2023 LCD Module  8/4/1999
// LCD Command
#define LCD_CLEAR 0x01
#define LCD_HOME  0x02
#define Display_ON 0x0C
#define Display_OFF 0x08
#define LCD_LINE1 0x80      // 0x00 + bit D7=1
#define LCD_LINE2 0xC0      // 0x40 + bit D7=1
#define LCD_LINE3 0x94      // 0x14 + bit D7=1
#define LCD_LINE4 0xD4      // 0x54 + bit D7=1

extern const code char mesg0[]="                   ";
extern void strConstRamCpy(unsigned char *dest, const code char *source);
extern void CRLF1(void) ;
extern unsigned char Adr;
extern unsigned char * txt;
//extern unsigned char dummy;
//extern unsigned char lcddata;


unsigned char I2C_PCF8574_Write(unsigned char  Adresse,unsigned char value);
void LCD_init_4x20(void);
void LCD_putch(unsigned char d); 
void LCD_Chr(unsigned char L,unsigned char x,unsigned char d);  
void LCD_puts(char *s);
void LCD_putsRom(code char *s);
void LCD_Out(unsigned char L,unsigned char x,const code char *CT);
void LCD_Cmd(unsigned char d);
void LCD_One_Cmd(unsigned char d);   // uniquement pour Init LCD
void Erase_Line(int L) ;  // new

//fonctions LCD derives
void LCD_Msg_Status(const char* T);  // affiche un TEXTE en ligne 4
void LCD_Write_CText(const char *txt) ;
void LCDHandler(char c);