  //rev 05-11-2017
  // simplification  affichage Time et Date , si on a pas besoin de faire du traiement sur date et time
  //  void BCD_To_Ascii(unsigned char cc,unsigned char *pp);
 //rev 30-09-2017
#include "Tiny_RTC_DS1307.h"

void write_ds1307(unsigned short address,unsigned short w_data)  // I2C WRITE
 {
  I2C1_Start();
  I2C1_Wr(DS1307_ADDR);
  I2C1_Wr(address);
  I2C1_Wr(w_data);
  I2C1_Stop();
 }
 
unsigned short read_ds1307(unsigned short address)      // I2C read subroutine
{unsigned  short  clock_data  ;
  I2C1_Start();
  I2C1_Wr(DS1307_ADDR);
  I2C1_Wr(address); 
  I2C1_Repeated_Start();
  I2C1_Wr(DS1307_ADDR+1);
  clock_data=I2C1_Rd(0);
  I2C1_Stop();
  return(clock_data);
 }
 
 
 void BCD_To_Ascii(unsigned char cc,unsigned char * px)
 {
 *(px)=(cc>>4) + 48;
 *(px+1)=(cc & 0x0F) +48;
 *(px+2)=0;
 }
 

void Refresh_display_date_Time(void)
{
     second=read_ds1307(0);
     minute=read_ds1307(1);
     heure =read_ds1307(2);
     jS=read_ds1307(3);
     jour=read_ds1307(4);
     mois=read_ds1307(5);
     Annee=read_ds1307(6);
     BCD_To_Ascii(heure,time) ;   time[2]=':';
     BCD_To_Ascii(minute,time+3 );  time[5]=':';
     BCD_To_Ascii(second,time+6);   time[8]=0;
     BCD_To_Ascii(jour,date); date[2]='-';
     BCD_To_Ascii(mois,date+3); date[5]='-';
     BCD_To_Ascii(Annee,date+6); date[8]=0;
    // Re-Lecture RTC  :   05-11-17 14:37:24

  }
  

void MAJ_RTC()
{ int m,i,j;
  m=2; // passe par dessus "U;"
  // U;24;08;17;4;17;36#
  //ou
  //  // U;24;08;17;04;17;36#
  j=0;
  //Status=0;
  RC1IE_bit = 0;
  *(Buffer1+Index1)=0;
   if ((Index1<21)&&(Index1>18))
    {
        UART1_Write_CText(" Index1 = ");
        WordToStr(Index1,CRam1);
        UART1_Write_Text(CRam1);
        CRLF1();
        for (i=2;i<Index1;i++)
        {
          if(Buffer1[i]==';')
              {
                Buffer1[i]=0;
                DateTime[j]=atoi(Buffer1+m);
                m=i+1;
                j++;
              }
       }// for i
       // ne pas oublier le dernier!
        DateTime[j]=atoi(Buffer1+m);


        jour=DateTime[0];
        mois=DateTime[1];
        Annee=DateTime[2];
        jS=DateTime[3]; // jour de la semaine sur 1 seul digit
        heure=DateTime[4];
        minute=DateTime[5];

        write_ds1307(0,0x00); //Reset second to 0 sec. and stop Oscillator
        write_ds1307(1,Dec2Bcd(minute)); //write min
        write_ds1307(2,Dec2Bcd(heure)); //write hour
        write_ds1307(3,Dec2Bcd(jS)); //write day of week
        write_ds1307(4,Dec2Bcd(jour)); // write date
        write_ds1307(5,Dec2Bcd(mois)); // write month
        write_ds1307(6,Dec2Bcd(Annee)); // write year 2014

      write_ds1307(7,0x10); // Sortie SQW  1Hz
       //  write_ds1307(7,0x11); // Sortie SQW  4096 Hz
      //  write_ds1307(7,0x12); // Sortie SQW  8192 Hz
       // write_ds1307(7,0x13); // Sortie SQW  32768 Hz
      UART1_Write_CText("\r\nEcriture dans DS1307... OK\r\n");
    }
    else
    {
    UART1_Write_CText("\r\n Rappel format de cde : \"U;24;08;17;04;17;36#\" \r\n");
    UART1_Write_CText(" pour 24 Aout 2017 Jeudi 17H36\r\n\r\n");
    }
   Delay_ms(100);
   Buffer1[0]=0;
   j=0;
   i1=0;
   Index1=0;
   Flag_Buffer1 =0;
   c1=RCREG1; // pour RAZ RC1IF_bit
   RC1IE_bit = 1;
 }

/*
 void Write_To_24LC256(unsigned int Adr, unsigned char cx)
{
I2C1_Is_Idle();
I2C1_Start();
I2C1_Wr(EEPROM_32K_ADR );      // write
I2C1_Wr(Hi(Adr));    // send data (data to be written)
I2C1_Wr(Lo(Adr));
//I2C1_Repeated_Start();
I2C1_Wr(cx);    // send data (data to be written)
I2C1_Stop();

}

unsigned char Read_From_24LC256(unsigned int Adr)
{
unsigned char c3;
I2C1_Is_Idle();
I2C1_Start();
I2C1_Wr(EEPROM_32K_ADR );  // write
I2C1_Wr(Hi(Adr));    // send adress to be read)
I2C1_Wr(Lo(Adr));
I2C1_Repeated_Start();
I2C1_Wr(EEPROM_32K_ADR+1 );  // Read
//Delay_ms(5);
c3=I2C1_Rd(0u);    // data to be read)
I2C1_Stop();
return c3;
}
*/
