#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F26K22_Velo_2017/_18F26K22_Velo_LCD4x20_I2C_24FC1026_uses_float_171120.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 176 "C:/_MikroC/_MesProjets_MikroC/_18F26K22_Velo_2017/_18F26K22_Velo_LCD4x20_I2C_24FC1026_uses_float_171120.c"
const code char mesg0[]="                    ";
const code char mesg1[]=" Mikroc pro 7.1.0 18F26K22+ 24FC1026 + IT UART1 + BT HC06\n\r";
const code char mesg2[] =" Source : " "_18F26K22_Velo_LCD4x20_I2C_24FC1026_uses_float" "_" "171120" ".c\r\n";
const code char mesg3[]=" calcul kms en flottant\n\r";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3};







sbit Led_Rouge at LATA.B4;
sbit Led_Rouge_Dir at TRISA.B4;

sbit BT_Reset at LATC.B1;
sbit Pulse_Inp at PORTB.B0;
sbit RTC_forcee at PORTB.B1;
sbit BP_Start at PORTB.B2;
sbit BP_Stop at PORTB.B3;
sbit BT_Reset_Dir at TRISC.B1;
sbit Pulse_Inp_Dir at TRISB.B0;
sbit RTC_forcee_Dir at TRISB.B1;
sbit BP_Start_Dir at TRISB.B2;
sbit BP_Stop_Dir at TRISB.B3;


volatile unsigned char Buffer1[ 120 ];
volatile int Flag_Buffer1;
unsigned char *p1;
volatile unsigned int i1;
volatile int Index1;
volatile unsigned char c1;
volatile unsigned int CptErr;

volatile unsigned char Buffer2[ 80 ];
unsigned char *p2;
volatile int Flag_Buffer2;
volatile unsigned int i2;
volatile int Index2;
volatile unsigned char c2;
volatile unsigned int CptErr2;

volatile unsigned int Count0;
volatile volatile unsigned int Count1;
volatile unsigned int Count2;
volatile int Flag_Timer0;
volatile int Flag_Timer1;
volatile int Flag_Timer2;
volatile int NbCycles_T1;
volatile unsigned int Duty;

int i,j,k,l;
int sk;
unsigned char TEXTE[ 120 ];
unsigned char * txt;
char CRam1[ 80 ];
char CRam2[32];
char Tampon[ 32 ];
int EAn0,EAn1,EAn2;
unsigned char N1;
unsigned char donnee;
unsigned int addr;
unsigned int Adr_24FC1026;
unsigned int Adr_24C32;
unsigned int erreurs;
unsigned char err;
unsigned int NumPage, Idx;
static unsigned char Page_Eeprom[128];
unsigned char Device_Adresse;
unsigned char Bloc;
int Etat;

unsigned long L1;

unsigned int Is;
unsigned char Sorties_1;
unsigned char Entrees_1;
unsigned char Dummy;
unsigned int Index;
unsigned int M;

unsigned char Adr;



float F1;
float Nb_Kms=0.0;
float Nb_TdP=0.0;
float Old_Nb_TdP=0.0;
float NbTdpPerMn=0.0 ;

unsigned int Nb_Hecto=0;
unsigned int Nb_Pu=0;
unsigned int Nb_P=0;


unsigned long TimeNow;
unsigned long TimeStop;
unsigned long EcartTime;
unsigned long OldTime ;
unsigned long TimeStart;
unsigned int Velo_Status;

unsigned long Nb_Pulses=0;
unsigned long Delta_Pulses=1;
unsigned long Old_Nb_Pulses=0;
float Cumul_Kms ;

struct chbits {
 unsigned FrameErr:1;
 unsigned Store:1;
 unsigned Elapsed:1;
 unsigned Togle:1;
 unsigned Stop;
 unsigned Gie:1;
 unsigned Full:1;
 unsigned Started:1;
 }Drapeaux ;


char time[]="00:00:00\0";
char date[]="00/00/00\0";
const code char Jour0[]="Diman";
const code char Jour1[]="Lundi";
const code char Jour2[]="Mardi";
const code char Jour3[]="Mercr";
const code char Jour4[]="Jeudi";
const code char Jour5[]="Vendr";
const code char Jour6[]="Samed";
const code char * JourSemaine[]={Jour0,Jour1,Jour2,Jour3,Jour4,Jour5,Jour6};

unsigned short second,minute,heure,jS,jour,mois,Annee;
unsigned short DateTime[10];

float Speed;


float VHV, VHV_IGBT;
unsigned long L=0;

void Init_Hardware(void) ;
void Read_Msg_Eeprom( int depuis);
void Write_Msg_Eeprom( int Adr,const char * d1) ;
void Init_Timer0(void);
void Init_Timer1 (void);
void Init_Timer2 (void);
void CRLF1(void) ;
void Raz_Buffer1(void) ;
void UART1_Write_CText(const char *txt);
void strConstRamCpy(unsigned char *dest, const code char *source);
void Float2Ascii (float x, unsigned char *chaine,char precision) ;
void CRLF2(void) ;
void Raz_Buffer2(void) ;
void UART2_Write_CText(const char *txt);

void PrintHandler(char c) ;


void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(unsigned char PtrE);


void Write_To_24FC1026(unsigned int Adr, unsigned char c);
unsigned char Read_From_24FC1026(unsigned int Adr);
void Write_Page_To_24FC1026(unsigned int Page);
void Read_Page_From_24FC1026(unsigned int Page);
void Affiche_Page_Eeprom(void);

void Save_NumPage_24FC1026_To_PIC_Eeprom(void);
void Save_Date_Time_To_24FC1026(void);
void Restore_NumPage_24FC1026_From_PIC_Eeprom(void);
void Read_NumPage_From_24FC1026(unsigned int Page);
void Restore_Last_Cumul_Kms_From_PIC_Eeprom(void) ;
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f26k22_velo_2017/lcd_4x20_i2c.h"
#line 26 "c:/_mikroc/_mesprojets_mikroc/_18f26k22_velo_2017/lcd_4x20_i2c.h"
extern const code char mesg0[]="                   ";
extern void strConstRamCpy(unsigned char *dest, const code char *source);
extern void CRLF1(void) ;
extern unsigned char Adr;
extern unsigned char * txt;




unsigned char I2C_PCF8574_Write(unsigned char Adresse,unsigned char value);
void LCD_init_4x20(void);
void LCD_putch(unsigned char d);
void LCD_Chr(unsigned char L,unsigned char x,unsigned char d);
void LCD_puts(char *s);
void LCD_putsRom(code char *s);
void LCD_Out(unsigned char L,unsigned char x,const code char *CT);
void LCD_Cmd(unsigned char d);
void LCD_One_Cmd(unsigned char d);
void Erase_Line(int L) ;


void LCD_Msg_Status(const char* T);
void LCD_Write_CText(const char *txt) ;
void LCDHandler(char c);
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f26k22_velo_2017/tiny_rtc_ds1307.h"










extern int Status;
extern unsigned char Adr;
extern char time[]="00:00:00";
extern char date[]="00/00/00";
extern unsigned short second,minute,heure,jS,jour,mois,Annee;
extern unsigned short DateTime[9];
extern unsigned char Buffer1[];
extern unsigned int Index1;
extern unsigned char ch[3];

extern void CRLF1(void);
extern unsigned int i1;
extern volatile int Flag_Buffer1;
extern unsigned char c1;
extern unsigned char CRam1[32];
extern void UART1_Write_CText(const char *txt);


extern const code char Jour0[]="Dimanche";
extern const code char Jour1[]="Lundi";
extern const code char Jour2[]="Mardi";
extern const code char Jour3[]="Mercredi.";
extern const code char Jour4[]="Jeudi";
extern const code char Jour5[]="Vendredi";
extern const code char Jour6[]="Samedi";
extern const code char * JourSemaine[]={Jour0,Jour1,Jour2,Jour3,Jour4,Jour5,Jour6};

void write_ds1307(unsigned short address,unsigned short w_data) ;
unsigned short read_ds1307(unsigned short address) ;
void Refresh_display_date_Time(void);
void MAJ_RTC(void);
void BCD_To_Ascii(unsigned char cc,unsigned char *pp);
unsigned short Dec2Bcd(unsigned short decnum);
#line 355 "C:/_MikroC/_MesProjets_MikroC/_18F26K22_Velo_2017/_18F26K22_Velo_LCD4x20_I2C_24FC1026_uses_float_171120.c"
void Interrupt_High() iv 0x0008 ics ICS_AUTO
{

 if ( (INT0IE_bit==1) && (INT0IF_bit==1))
 {
 Nb_Pulses++;
#line 381 "C:/_MikroC/_MesProjets_MikroC/_18F26K22_Velo_2017/_18F26K22_Velo_LCD4x20_I2C_24FC1026_uses_float_171120.c"
 if (Nb_Pulses %3==0) Led_Rouge=!Led_Rouge;
 if(BP_Stop==0)Velo_Status=0;
 INT0IF_bit = 0 ;
 }

 if ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
 {
 TMR1H = 0x3C;
 TMR1L = 0xB0;
 Count1++;
 if (Count1>=NbCycles_T1)
 {
 Count1=0;
 Flag_Timer1=1;
 TMR1IE_bit=0;
 }
 PIR1.TMR1IF=0;
 }


 if ( (TMR0IE_bit==1) && ( TMR0IF_bit==1))
 {

 TMR0H = 0x0B;
 TMR0L = 0xDC;




 Flag_Timer0=1;


 TMR0IF_bit=0;
 }

 if (( RC1IF_bit==1) && (RC1IE_bit==1) )
 {

 c1 = UART1_Read();



 if (RCSTA1.OERR==1)
 {
 RCSTA1.CREN = 0 ;
 CptErr++;
 RCSTA1.CREN = 1 ;
 c1=0;

 }
 if(RCSTA1.FERR==1 )
 {
 RCSTA1.SPEN = 0 ;
 CptErr++;
 RCSTA1.SPEN= 1 ;
 c1 = UART1_Read();
 }
 if ((c1== 13 ) || (i1> 120 -1))
 {
 Flag_Buffer1=1;
 Buffer1[i1]=0;
 RC1IE_bit=0;
 Index1=i1;
 i1=0;
 }
 else
 {
 Flag_Buffer1=0;
 Buffer1[i1]=c1;
 Index1=i1;
 i1++;
 }
 }
 if (( RC2IF_bit==1) && (RC2IE_bit==1) )
 {

 c2 = UART2_Read();
 TXREG2=c2;


 if (RCSTA2.OERR==1)
 {
 RCSTA2.CREN = 0 ;
 CptErr++;
 RCSTA2.CREN = 1 ;
 c2=0;

 }
 if(RCSTA2.FERR==1 )
 {
 RCSTA2.SPEN = 0 ;
 CptErr++;
 RCSTA2.SPEN= 1 ;
 c2 = UART2_Read();
 }
 if ((c2== 13 ) || (i2> 80 -1))
 {
 Flag_Buffer2=1;
 Buffer2[i2]=0;
 RC2IE_bit=0;
 Index2=i2;
 i2=0;
 }
 else
 {
 if(c2!= 10 )
 {
 Flag_Buffer2=0;
 Buffer2[i2]=c2;
 Index2=i2;
 i2++;
 }
 }
 }

 }


void strConstRamCpy(unsigned char *dest, const code char *source)
 {
 while (*source)*dest++ = *source++ ;
 *dest = 0 ;
}


void Read_Msg_Eeprom( unsigned char debut)
{ int i1 ,i;
 i1=debut;
 do
 {
 i = EEPROM_Read(i1);
 if ( i==0) break;
 if ( i1>254) break;
 UART1_Write(i);
 Tampon[i1-debut]=i;
 Delay_ms(5);
 i1++;
 }
 while (i!=0) ;
 }


 void Init_Timer0(void)
 {


 T0CON = 0x86;
 TMR0H = 0x0B;
 TMR0L = 0xDC;
 TMR0IE_bit = 1;
 Flag_Timer0=0;
 INTCON.TMR0IF=0;
 TMR0ON_bit=1;
 }


int Init_BT_With_feeback()
{
 int i=0;
 int State=0;
 LCD_Cmd( 0xC0 );
 LCD_Write_CText("INIT.BT HC06 JAUNE  ");
 LCD_Cmd( 0x94 );
 LCD_Write_CText("Etape: 1 sur 4"); Delay_ms(500);

 do
 {
 UART2_Write_CText("AT");
 UART1_Write_CText("AT\r\n");
 Delay_ms(1500); i++;
 }while(i<3);

 State=0;
 i=0;

 UART1_Write_CText("RAZ Buffer2\r\n");
 Raz_Buffer2();
 UART2_Write_CText("AT");
 UART1_Write_CText("AT\r\n");
 Init_Timer0();
 do
 {
 Delay_ms(100);
 p2=strstr(Buffer2,"OK");
 if(p2>0)
 {
 State=1;
 break;
 }
 }while((Flag_Timer0==0) && (Index2<2));

 UART1_Write_Text(Buffer2);
 if(Flag_Timer0==1)return State;
 Buffer2[19]=0; LCD_Cmd( 0xD4 ); LCD_puts(Buffer2);
 Delay_ms(500);


 LCD_Cmd( 0x94 );
 LCD_Write_CText("Etape: 2 sur 4"); Delay_ms(500);
 Raz_Buffer2();
 UART2_Write_CText("AT+PIN1234");
 Init_Timer0();
 do
 {
 Delay_ms(100);
 p2=strstr(Buffer2,"OKsetPIN");
 if(p2>0)
 {
 State=2;
 break;
 }
 }while((Flag_Timer0==0) && (p2==0));
 UART1_Write_Text(Buffer2);
 if(Flag_Timer0==1) return State;
 Buffer2[19]=0; LCD_Cmd( 0xD4 ); LCD_puts(Buffer2);
 Delay_ms(500);

 LCD_Cmd( 0x94 );
 LCD_Write_CText("Etape: 3 sur 4"); Delay_ms(500);
 Raz_Buffer2();

 UART2_Write_CText("AT+NAMEHC06-2187J");
 Buffer2[19]=0; LCD_Cmd( 0xD4 ); LCD_puts(Buffer2);
 Init_Timer0();
 do
 {
 Delay_ms(100);
 p2=strstr(Buffer2,"OKsetname") ;
 if(p2>0)
 {
 State=3;
 break;
 }
 }while((Flag_Timer0==0) && (p2==0));
 UART1_Write_Text(Buffer2);
 if(Flag_Timer0==1) return State;
 Buffer2[19]=0; LCD_Cmd( 0xD4 ); LCD_puts(Buffer2);
 Delay_ms(500);

 LCD_Cmd( 0x94 );
 LCD_Write_CText("Etape: 4 sur 4"); Delay_ms(500);
 Raz_Buffer2();
 UART2_Write_CText("AT+VERSION");
 Init_Timer0();
 Buffer2[19]=0; LCD_Cmd( 0xD4 ); LCD_puts(Buffer2);
 do
 { Delay_ms(100);
 p2=strstr(Buffer2,"OKlinvor");
 if(p2>0)
 {
 State=4;
 break;
 }
 }while((Flag_Timer0==0) && (p2==0));
 UART1_Write_Text(Buffer2);
 if(Flag_Timer0==1) return State;
 Delay_ms(500); Buffer2[19]=0; LCD_Cmd( 0xD4 ); LCD_puts(Buffer2);
 CRLF1();
 State=5;
 Delay_ms(500);
 Raz_Buffer2();
 return(State);
 }


void Init_Timer1(int Va)
{



 T1CON = 0x30;
 TMR1IF_bit = 0;
 TMR1H = 0x3C;
 TMR1L = 0xB0;
 TMR1CS1_bit=0;
 TMR1CS0_bit=0;
 Count1=0;
 NbCycles_T1=Va;
 Flag_Timer1=0;
 TMR1ON_bit=1;
 TMR1IE_bit=1;
}

void Init_Hardware()
{
 ANSELA =0b00000011;
 PORTA = 0b00000111;
 TRISA = 0b00101111;
 Led_Rouge_Dir=0;

 ANSELB=0;
 PORTB = 0xFF;
 TRISB = 0xFF;
 TRISB.B7 = 1;
 TRISB.B6 = 1;
 Pulse_Inp_Dir =1;

 RTC_forcee_Dir =1;
 BP_Start_Dir =1;
 BP_Stop_Dir =1;

 ANSELC=0;
 PORTC = 0x80;
 TRISC = 0xFF;

 TRISC.B3 = 0;
 TRISC.B4 = 1;
 TRISC.B7 = 1;
 TRISC.B6 = 1;

 BT_Reset_Dir =0;

 }

void PrintHandler(char c)
 {
 UART1_Write(c);
}

void CRLF1()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
}

void UART1_Write_CText(const char *txt)
 {
 while (*txt)
 UART1_Write(*txt++);
}

void Raz_Buffer1()
{

 Index1=0;
 Flag_Buffer1 =0;

 for(i1=0;i1< 120 -1;i1++)Buffer1[i1]=0;
 c1=RCREG1;
 i1=0;
 RC1IE_bit = 1;
}

void UART2_Write_CText(const char *txt)
 {
 while (*txt)
 UART2_Write(*txt++);
}


void CRLF2()
{
 UART2_Write( 13 );
 UART2_Write( 10 );
}

void Raz_Buffer2()
{

 Index2=0;
 Flag_Buffer2 =0;

 for(i2=0;i2< 80 -1;i2++)Buffer2[i2]=0;
 Index2=0;
 i2=0;
 c2=RCREG2;
 RC2IE_bit = 1;
}


void Write_To_24FC1026(unsigned int Adr, unsigned char cx)
{
 Device_Adresse=  0xA8 + Adr>>9;
I2C1_Is_Idle();
I2C1_Start();
err=I2C1_Wr(Device_Adresse );
err=I2C1_Wr( ((char *)&Adr)[1] );
err=I2C1_Wr( ((char *)&Adr)[0] );
err=I2C1_Wr(cx);
I2C1_Stop();
I2C1_Is_Idle();
Delay_ms(5);
}

unsigned char Read_From_24FC1026(unsigned int Adresse)
{
unsigned char c3;
Device_Adresse=  0xA8 ;

I2C1_Is_Idle();
 Delay_ms(1);
I2C1_Start();
err=I2C1_Wr(Device_Adresse );
err=I2C1_Wr( ((char *)&Adresse)[1] );
err=I2C1_Wr( ((char *)&Adresse)[0] );
I2C1_Is_Idle();
 Device_Adresse=  0xA8  + 1;

I2C1_Repeated_Start();
err=I2C1_Wr(Device_Adresse );
c3=I2C1_Rd(0u);
I2C1_Stop();
I2C1_Is_Idle();
return c3;
}

void Write_Page_To_24FC1026(unsigned int Page)
{
 unsigned int Ad;
 unsigned char Is;
 if(GIE_bit) Is=1;
 GIE_bit=0;
 erreurs=0;
 Device_Adresse=  0xA8  ;
 Ad=Page << 7;
 I2C1_Is_Idle();
 I2C1_Start();
 err=I2C1_Wr(Device_Adresse );
 err=I2C1_Wr( ((char *)&Ad)[1] );
 err=I2C1_Wr( ((char *)&Ad)[0] );
 if (err>0) erreurs++;
 for (Ad=0;Ad<127;Ad++)
 {
 err=I2C1_Wr(Page_Eeprom[Ad]);
 if(err>0) erreurs++;
 }
 I2C1_Stop();
 I2C1_Is_Idle();
 if (Is==1)GIE_bit=1;
}

void Read_NumPage_From_24FC1026(unsigned int Page)
{
 unsigned int Ad;
 unsigned char AdreH,AdreL;
 unsigned char Is;
 if(GIE_bit) Is=1;
 GIE_bit=0;
 Ad=(Page << 7) ;
 AdreH= ((char *)&Ad)[1] ;
 AdreL= ((char *)&Ad)[0] ;
 Device_Adresse=  0xA8 ;




 I2C1_Is_Idle();
 I2C1_Start();
 err=I2C1_Wr( Device_Adresse );
 err=I2C1_Wr( ((char *)&Ad)[1] );
 err=I2C1_Wr( ((char *)&Ad)[0] );
 I2C1_Repeated_Start();
 err=I2C1_Wr( Device_Adresse+1 );
 I2C1_Is_Idle();
 for (Ad=0;Ad<127;Ad++)
 {
 Page_Eeprom[Ad]=I2C1_Rd(1u);
 }
 Page_Eeprom[Ad]=I2C1_Rd(0u);
 I2C1_Stop();
 I2C1_Is_Idle();
 if (Is==1)GIE_bit=1;
}

 void Save_Cumul_Kms_To_PIC_Eeprom(void)
 {
 unsigned char cx;
 cx= ((char *)&Cumul_Kms)[0] ;
 EEPROM_Write(0x03FA,cx); Delay_ms(20);
 cx= ((char *)&Cumul_Kms)[1] ;
 EEPROM_Write(0x03FB,cx); Delay_ms(20);
 cx= ((char *)&Cumul_Kms)[2] ;
 EEPROM_Write(0x03FC,cx); Delay_ms(20);
 cx= ((char *)&Cumul_Kms)[3] ;
 EEPROM_Write(0x03FD,cx); Delay_ms(20);
 sprintf(txt,"\r\n Sauve Cumul_Kms %5.1f dans EEPROM du PIC ,  0x03FA...0x03FD=LSB\r\n",Cumul_Kms);
 UART1_Write_Text(txt) ;
}



void Save_NumPage_24FC1026_To_PIC_Eeprom(void)
{unsigned char cx;
 Idx=0;
 cx=(NumPage >> 8 );
 EEPROM_Write(0x03FE,cx); Delay_ms(20);
 cx=NumPage & 0x00FF;
 EEPROM_Write(0x03FF,cx); Delay_ms(20);
 sprintf(txt,"\r\n Sauve Numpage % 3d dans EEPROM du PIC , at 0x03FE =MSB et 0x03FF=LSB\r\n",NumPage);
 UART1_Write_Text(txt) ;
}

 void Save_Date_Time_To_24FC1026(void)
 { int i;
 for (i=0;i<128;i++)Page_Eeprom[i]=0;
 Refresh_display_date_Time() ;
 Idx=0;
 UART1_Write_CText("\r\n Stockage horodatage\t");
 strncpy(Page_Eeprom+Idx,date,5);
 Idx=5;
 Page_Eeprom[Idx]=';';
 Idx=6;
 strncpy(Page_Eeprom+Idx,time,5);Idx=11;
 Page_Eeprom[Idx]=';';Idx=12; Page_Eeprom[12]=0;
 txt=TEXTE;
 sprintf(txt,"\r\n DateTime=  %s   next Idx Page_Eeprom = % 5d  \r\n",Page_Eeprom,Idx);
 UART1_Write_Text(txt);
}




void Restore_NumPage_24FC1026_From_PIC_Eeprom()
 { int k;

 Dummy= EEPROM_Read(0X03FE) ;
 k=Dummy;
 Dummy=EEPROM_Read(0x03FF) ;
 NumPage=(k <<8) + Dummy;
 if (NumPage==0xFFFF) NumPage=0;
 UART1_Write_CText( " NumPage 24FC1026 recupre de L'EEPROM du PIC en 0x03FE et 0x3FF= ");
 txt=TEXTE;
 WordToStr( NumPage, txt);
 UART1_Write_Text(txt);
 CRLF1();
 Idx=0;
 }



 void Restore_Last_Cumul_Kms_From_PIC_Eeprom()
 { int k;
 unsigned char cx;
 cx= EEPROM_Read(0X03FA) ;
 if(cx==0xFF) Cumul_Kms=0.0;
 else
 {
  ((char *)&Cumul_Kms)[0] =cx;
 cx= EEPROM_Read(0X03FB) ;
  ((char *)&Cumul_Kms)[1] =cx;
 cx= EEPROM_Read(0X03FC) ;
  ((char *)&Cumul_Kms)[2] =cx;
 cx= EEPROM_Read(0X03FD) ;
  ((char *)&Cumul_Kms)[3] =cx;
 }
 sprintf(txt," Last Cumul Kms recupre de L'EEPROM du PIC en 0x03FA..0x03FD= % 5.1f\r\n ",Cumul_Kms);
 UART1_Write_Text(txt);
 }


void Affiche_Page_Eeprom()
{
 int i;
 for (i=0;i<128;i++)
 {
 if (i%8==0)
 {
 CRLF1();
 WordToStr(i,txt);
 UART1_Write_Text(txt); UART1_Write( 9 );
 }
 ByteToStr(Page_Eeprom[i],txt);
 UART1_Write_Text(txt);UART1_Write( 9 );
 }
}


void Float2Ascii (float z, unsigned char *str,char precision)
{


 float x;
 int ie, i, k, ndig;
 double y;
 x=z;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;

 if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

 if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
 while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }

 ndig += ie;


 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
 *str = '\0';
}


void I2C1_TimeoutCallback(char errorCode)
{
 if (errorCode == _I2C_TIMEOUT_RD) {

 }
 if (errorCode == _I2C_TIMEOUT_WR) {

 }
 if (errorCode == _I2C_TIMEOUT_START) {

 }
 if (errorCode == _I2C_TIMEOUT_REPEATED_START) {

 }
}

void Affiche_Time(int ModeOutput)
{

 TimeNow=Bcd2Dec16(heure)*3600+Bcd2Dec16(minute)*60+Bcd2Dec16(second);
 switch(ModeOutput )
 {
 case 0:
 UART1_Write_Text( date); UART1_Write(';');
 UART1_Write_Text(time);
 UART1_Write(';');
 break;
 case 1:
 LCD_Cmd( 0x80 );
 if (Drapeaux.Togle==1)
 {
 LCD_Write_CText("TIME: ");
 LCD_Cmd( 0x80 +6);
 LCD_puts(time);
 }
 else
 {
 LCD_Write_CText("DATE: ");
 LCD_Cmd( 0x80 +6);
 LCD_puts(date);
 LCD_Cmd( 0x80 +15);
 LCD_Write_CText(JourSemaine[jS]);

 }
 break;
 case 2:
 UART1_Write_CText(JourSemaine[jS]);UART1_Write(' ');
 UART1_Write_Text( date); UART1_Write(' ');
 UART1_Write_Text(time);
 CRLF1();
 break;
 case 3:

 strConstRamCpy(txt,JourSemaine[jS]);
 strcat(txt,";");
 strcat(txt,date);
 strcat(txt,";");
 strcat(txt,time);
 strcat(txt,";\r\n");
 UART2_Write_Text(txt);
 break;
 }
 }


void main()
 {


 OSCCON=2;
#line 1081 "C:/_MikroC/_MesProjets_MikroC/_18F26K22_Velo_2017/_18F26K22_Velo_LCD4x20_I2C_24FC1026_uses_float_171120.c"
 OSCCON=0;
 OSCCON.IRCF2=1;
 OSCCON.IRCF1=1;
 OSCCON.IRCF0=0;
 OSCTUNE=0;
 OSCTUNE.PLLEN=1;
#line 1092 "C:/_MikroC/_MesProjets_MikroC/_18F26K22_Velo_2017/_18F26K22_Velo_LCD4x20_I2C_24FC1026_uses_float_171120.c"
 Delay_1sec();
 Init_Hardware() ;
 Led_Rouge=0;

 RCSTA2.CREN=0;
 RCSTA1.CREN=0;
 RC1IE_bit = 0;
 GIE_bit=0;
 BT_Reset=0;

 txt=&TEXTE[0];
#line 1113 "C:/_MikroC/_MesProjets_MikroC/_18F26K22_Velo_2017/_18F26K22_Velo_LCD4x20_I2C_24FC1026_uses_float_171120.c"
 UART1_Init(19200);
 UART1_Write( 12 );
 Delay_ms(500);

 UART1_Write_CText(Messages[1]);
 UART1_Write_CText(Messages[2]);
 UART1_Write_CText(Messages[3]);
 Delay_1sec();







 BT_Reset=1;

 txt=&TEXTE[0];

 UART1_Write_CText(" Presentation :\r\n");
 Led_Rouge=1;
 Read_Msg_Eeprom(0x00);
 Read_Msg_Eeprom(0x20);
 Delay_1sec();


 Adr= 0x4E ;
 I2C1_Init(400000);
 I2C1_Stop();
 I2C1_SetTimeoutCallback(1000, I2C1_TimeoutCallback);

 Read_Msg_Eeprom(0x50);
 Led_Rouge=0;

 LCD_init_4x20();
 LCD_Cmd( 0x01 );


 LCD_Cmd( 0x01 );
 LCD_Cmd( 0x80 );LCD_Write_CText("18F26K22 MikroC 7.1 ");
 LCD_Cmd( 0xC0 ); LCD_Write_CText("Version : " "171120" );
 LCD_Cmd( 0x94 );LCD_Write_CText("UART1 UART2 19200bds");
 LCD_Cmd( 0xD4 );LCD_Write_CText("RTC,LCD sur bus I2C1");
 IPEN_bit=1;
 PEIE_bit=1 ;
 GIE_bit=1;
 Init_Timer1(100);
 while(Flag_Timer1==0);
 LCD_Cmd( 0x01 );
 PEIE_bit=0 ;
 GIE_bit=0;

 Read_Msg_Eeprom(0x70);

 if(RTC_forcee==0)
 {

 UART1_Write_CText( " Init RTC par defaut ");
 write_ds1307(0,0x80);
 write_ds1307(1,0x59);
 write_ds1307(2,Dec2Bcd(18));
 write_ds1307(3,0x01);
 write_ds1307(4,0x23);
 write_ds1307(5,0x10);
 write_ds1307(6,Dec2Bcd(17));
 write_ds1307(0,0x00);
 }
 else
 {
 UART1_Write_CText(" Re-Lecture RTC ");
 }
 CRLF1();
 Delay_1sec();


 Restore_NumPage_24FC1026_From_PIC_Eeprom() ;
 Refresh_display_date_Time();


 LCD_Cmd( 0x01 );
 Affiche_Time(1);
 Affiche_Time(2);

 LCD_Cmd( 0xC0 );
 LCD_Write_CText("FOSC Interne 32MHz  ");





 Restore_Last_Cumul_Kms_From_PIC_Eeprom();
 sprintf(txt,"Cumul Kms % 5.1f  ",Cumul_Kms);
 LCD_Cmd( 0x94 );LCD_puts(txt);
 PEIE_bit=1 ;
 GIE_bit=1;
 Init_Timer1(50);
 while(Flag_Timer1==0);


 PMD0.UART2MD=0;

 UART2_Init(19200);
 UART1_Write_CText(" Init UART2 pour HC06 BlueTooth link :\r\n");
 RCSTA2.CREN = 1;
 TXSTA2.TXEN=1;
 TXSTA2.SPEN=1;
 IPEN_bit=1;
 PEIE_bit=1 ;
 RC2IE_bit=1;
 GIE_bit=1;
#line 1241 "C:/_MikroC/_MesProjets_MikroC/_18F26K22_Velo_2017/_18F26K22_Velo_LCD4x20_I2C_24FC1026_uses_float_171120.c"
 Read_Msg_Eeprom(0x80);

 Erase_Line(3);
 k=Init_BT_With_feeback();
 TMR0ON_bit=0;
 Delay_ms(500);
 Adr= 0x4E ;
 LCD_Cmd( 0x94 );
 if(k>4)
 sprintf(txt,"Init BT OK State=%02d ",k);
 else
 sprintf(txt, "BAD Init or Connecte");
 LCD_puts(txt);
 sprintf(txt,"Allready Connected or Bad Init BT State=%02d\r\n",k);
 UART1_Write_Text(txt);
 Delay_ms(2500);


 RCSTA1.CREN = 1;
 c1=RCREG;
 Raz_Buffer1();

 Nb_Pulses=0L;
 Nb_Kms=0.0;
 Nb_TdP=0.0;
 Led_Rouge=1;
 UART1_Write_CText("Commencer  pedaler ..\r\n");
 Adr= 0x4E ;
 LCD_Cmd( 0x94 );
 LCD_Write_CText ("Pedaler pour Debuter");


 j=0;
 k=0;
 Velo_Status=0;


 CRLF1();
 LCD_Cmd( 0xD4 );
 if (BP_Stop==0) LCD_Write_CText (" Enlever le STOP... ");
 while(BP_Stop==0) ;
 Erase_Line(3);
 Erase_Line(4);
 do
 {
 Refresh_display_date_Time();
 Affiche_Time(1);
 if(BP_Stop==0) j=0;
 if( (k==1) &&(PORTB.B0==1))
 {
 Delay_ms(100);
 j++;
 k=0;
 Led_Rouge=1;
 }

 if((k==0)&& (PORTB.B0==0))
 {
 Delay_ms(100);
 j++;
 k=1;
 Led_Rouge=0;
 }
 if (Flag_Buffer1==1)
 {
 UART1_Write_Text(Buffer1);CRLF1();
 p1=Buffer1;

 if((*(p1)=='U') && (*(p1+19)=='#'))
 {
 Buffer1[19]=32; Buffer1[20]=0;
 LCD_Msg_Status("ReMise a l'Heure RTC");
 MAJ_RTC();

 }
 else
 {
 if(*(p1)=='U')
 {
 UART1_Write_CText("\r\n Rappel format de cde : \"U;24;08;17;04;17;36#\" \r\n");
 UART1_Write_CText(" pour 24 Aout 2017 Jeudi 17H36\r\n\r\n");
 }
 }
 Raz_Buffer1();
 }
 UART1_Write_CText("Comptage Nb tour de pedale  J =");
 WordToStr(j,CRam1);
 UART1_Write_Text(CRam1);
 CRLF1();

 LCD_Cmd( 0xC0 );
 LCD_Write_CText ("Nb Tr Pedale ");
 LCD_Cmd( 0xC0 + 13);
 LCD_puts (CRam1);
 Delay_ms(1000);
 }
 while((j<5) && (BP_Stop==1)) ;
 LCD_Cmd( 0x94 );
 if (BP_Stop==0)
 {
 LCD_Write_CText (" STOP ....          ");
 Delay_1sec();
 _asm goto 0;
 }
 else
 {
 LCD_Msg_Status("Compteur RUNNING   ");
 }
 Refresh_display_date_Time();
 Affiche_Time(1);
 Save_Date_Time_To_24FC1026() ;
 TimeStart=TimeNow;
 OldTime=TimeNow;
 Velo_Status=1;
 Drapeaux.Started=0;

 Old_Nb_Pulses=0;
 Delta_Pulses=0;
 Nb_Pulses=0;
 Nb_Kms=0.0;
 Nb_TdP=0;

 UART1_Write_CText(" Armement Interrupts RB0\r\n");


 c1=RCREG1;
 Raz_Buffer1();
 INTCON2.RBPU=0;
 INTCON2.INTEDG0=1;
 INT0IE_bit=1;
 IPEN_bit=1;
 IPR2=0;
 PEIE_bit=1;
 GIE_bit=1;
 Raz_Buffer2();

 Init_Timer1(200);

 UART1_Write_CText("Timer1 initialis  200x50mS => boucle en 10 sec\r\n");
 Drapeaux.Stop=0;
 j=0;

 do
 {
 Refresh_display_date_Time();
 Affiche_Time(1);
 Nb_Kms=(float)Nb_Pulses /  434 ;


 EcartTime=TimeNow - TimeStart;
 Nb_TdP=(float)Nb_Pulses/3.1;
 NbTdpPerMn =Nb_TdP*60.0/(float)EcartTime;
 if(j>5)
 {
 j=0;
 LCD_Cmd( 0xD4 );
 Delta_Pulses=Nb_Pulses-Old_Nb_Pulses;
 Speed=(float)Delta_Pulses/7.23;
 sprintf(txt, "Vitesse=% 5.2f Km/H",Speed);
 LCD_puts(txt);
 Old_Nb_Pulses=Nb_Pulses;

 Drapeaux.Togle=0;
 Drapeaux.Started=1;

 if (Drapeaux.Stop==1) Velo_Status=0;
 }
 else
 {
 LCD_Cmd( 0xC0 );
 sprintf(txt,"NbTdp% 7.0f % 3.2fKm",Nb_TdP,Nb_Kms);
 LCD_puts(txt);
 Drapeaux.Togle=1;
 if (EcartTime>0)
 {
 LCD_Cmd( 0x94 );
 sprintf(txt, "Pedalage= % 4.1f RPM",NbTdpPerMn);
 LCD_puts(txt);
 Drapeaux.Started=1;
 LCD_Cmd( 0xD4 );
 Speed= Nb_Kms*1000.0/(float)EcartTime;
 sprintf(txt, "Vitesse=% 5.2f M/S.",Speed);
 LCD_puts(txt);

 }

 }
 while(Flag_Timer1==0) ;

 Init_Timer1(200);
 if (Drapeaux.Started==1)
 {
 if (j==0)
 {
 UART1_Write_CText("  Nb_Pulses ; Nb_TdP ; Nb_Kms ; Speed ; NbTdpPerMn \r\n");
 }
 txt=&TEXTE[0];
 LongWordToStr(Nb_Pulses,txt);
 strcat(txt,";");
 Float2Ascii (Nb_TdP, CRam1,1) ;
 strcat(txt,CRam1);strcat(txt,";");
 Float2Ascii (Nb_Kms, CRam1,2) ;
 strcat(txt,CRam1);strcat(txt,";");
 Float2Ascii (Speed, CRam1,2) ;
 strcat(txt,CRam1);strcat(txt,";");
 Float2Ascii (NbTdpPerMn, CRam1,1) ;
 strcat(txt,CRam1);strcat(txt,";\r\n");
 UART1_Write_Text(txt);
 UART2_Write_Text(txt);

 }


 if (Flag_Buffer1==1)
 {



 p1=strstr(Buffer1,"Stop");
 if(p1>0)
 { Delay_100ms();
 UART1_Write_CText("\r\nStop via Terminal\r\n");
 Drapeaux.Stop=1 ;
 }
 Raz_Buffer1();
 }

 if (Flag_Buffer2==1)
 {
 CRLF1();
 UART1_Write_CText("Cde via HC06 : ");
 UART1_Write_Text(Buffer2);
 CRLF1();
 p2=strstr(Buffer2,"STOP");
 if(p2>0)
 {
 Delay_100ms();
 UART2_Write_CText("OK\r");
 Affiche_Time(3);
 Drapeaux.Stop=1 ;
 }
 Raz_Buffer2();
 }
 j++;
 }
 while ((Velo_Status==1)&& (BP_Stop==1) );

 Refresh_display_date_Time();
 INT0IE_bit = 0 ;
 GIE_bit=0;
 Affiche_Time(2);
 LCD_Msg_Status("STOP Compteur       ");
 TimeStop=TimeNow;
 EcartTime=TimeStop-TimeStart;
 Speed= Nb_Kms *3600.0 /((float) EcartTime );
 Float2Ascii (Speed, txt,2) ;
 LCD_Cmd( 0xC0 );
 sprintf(txt, "Nb TdP =% 6.0f     ",Nb_TdP);
 LCD_puts(txt);
 LCD_Cmd( 0x94 );
 sprintf(txt,"Vitesse moy.= %3.2f",Speed);
 LCD_puts(txt);
 LCD_Cmd( 0xD4 );
 sprintf(txt,"Nb Kms : = % 5.2f",Nb_Kms);
 LCD_puts(txt);
 sprintf(txt,"Start=%8lu sec;",TimeStart); UART1_Write_Text(txt);
 sprintf(txt,"Stop=%8lu sec;",TimeStop); UART1_Write_Text(txt);
 sprintf(txt,"Ecart=%8lu sec;Vitesse= %5.2f;",EcartTime,Speed);UART1_Write_Text(txt);CRLF1();
 sprintf(txt,"TTdP=% 6.0f;Kms=% 5.2f;Vmoy=% 5.2f;Duree=",Nb_TdP,Nb_Kms,Speed);
 l=strlen(txt);

 l=EcartTime/3600;
 *(CRam1)=l/10 +48;
 *(CRam1+1)=l%10 +48;
 *(CRam1+2)=':' ;

 j=EcartTime-(l*3600);
 j=j/60;
 *(CRam1+3)= j/10 +48;
 *(CRam1+4)= j%10 +48;
 *(CRam1+5)=':' ;
 k=EcartTime-l*3600-j*60;
 *(CRam1+6)=k/10 +48;
 *(CRam1+7)=k%10 +48;
 *(CRam1+8)=';';
 *(CRam1+9)=0;
 strcat(txt,CRam1);
 Cumul_Kms=Cumul_Kms+ Nb_Kms;
 sprintf(CRam1,"Cumul=% 5.1f\r\n",Cumul_Kms);
 UART1_Write_Text(txt);
 strcat(txt,CRam1);
 strcpy(Page_Eeprom+12,txt);
 UART1_Write_Text(Page_Eeprom);
 k= strlen(Page_Eeprom);
 Write_Page_To_24FC1026(NumPage) ;
 sprintf(txt,"Ecriture de k=% 5d bytes dans NumPage= % 5d  24FC1026\r\n",k,NumPage);
 UART1_Write_Text(txt);
 sprintf(txt,"ECRITURE 24FC1026 PAGE= % 5d\r\n",NumPage);
 UART2_Write_Text(txt);

 NumPage=NumPage+1;
 Save_NumPage_24FC1026_To_PIC_Eeprom() ;
 Save_Cumul_Kms_To_PIC_Eeprom() ;
 CRLF1();
 Raz_Buffer1();
 GIE_bit=1;

 do
 {
 Delay_ms(1000);

 if (Flag_Buffer1==1)
 {




 p1=strstr(Buffer1,"RELECT");
 if(p1>0)
 {
 UART1_Write_CText("\r\nRelecture 24FC1026 :");CRLF1();
 for (i=0;i<NumPage;i++)
 { k=i;
 Read_NumPage_From_24FC1026(k);
 UART1_Write_Text(Page_Eeprom);
 }
 CRLF1();
 }
 p1=strstr(Buffer1,"RESTART");
 if(p1>0)
 {
 UART1_Write_CText("\r\nReDemarrage, nouvel serie\r\n");
 Delay_ms(5000);
 _asm goto 0;
 }
 p1=Buffer1;

 if((*(p1)=='U') && (*(p1+19)=='#'))
 {
 Buffer1[19]=32; Buffer1[20]=0;
 LCD_Msg_Status("ReMise a l'Heure RTC");
 MAJ_RTC();
 }
 Raz_Buffer1();
 }

 if (Flag_Buffer2==1)
 {
 p2=Buffer2;

 if((*(p2)=='U') && (*(p2+19)=='#'))
 {
 Buffer2[19]=32; Buffer2[20]=0;
 LCD_Msg_Status("ReMise a l'Heure RTC");
 MAJ_RTC();
 }
 p2=strstr(Buffer2,"RESTART");
 if(p2>0)
 { Delay_100ms();
 UART2_Write_CText("OK\r");
 Delay_100ms();
 _asm goto 0;
 }
 Raz_Buffer2();
 }
 }
 while(1);
 }
